package de.hs_mannheim.informatik.bank.domain;

import java.io.Serializable;

public class Girokonto extends Konto implements Serializable {


	private long dispo = 1000;
	public Girokonto(String inhaber, int kontozhler, long dispo) {
		super(inhaber, kontozhler);
		this.dispo = dispo;
	}
	
	public boolean berweise(Girokonto ziel, long betrag, String zweck) {
		if (super.getKontostand() - betrag >= -dispo) {
			this.auszahlen(betrag, zweck, "berweisungsausgang", super.getInhaber());
			ziel.einzahlen(betrag, zweck, "berweisungseingang", super.getInhaber());
			
			return true;
		}
		return false;
	}
	
	@Override
	public boolean auszahlen(long betrag, String zweck, String art, String auftraggeber) {
		if (stand - betrag >= -dispo) {
			stand -= betrag;

			kontobewegungen.add(new Kontobewegung(betrag * -1, zweck, art, auftraggeber));

			return true;
		}

		return false;
	}
	
	
	@Override
	public String toString() {
		return "Giro-" + super.toString();
	}

}
